﻿Module Calcul_Frigorifique
    ''' <summary> Module de calcul du coefficient de transmission surfacique</summary>
    ''' <param name="verif"> variable prenant la valeur False si une erreur bloquante s'est produite pendant le calcul</param>
    ''' <param name="rtf">Stream pour la création du fichier RTF</param>
    Public Sub Bilan_Frigorifique(ByRef rtf As To_Rtf.RtfAnsiTextWriter, ByRef Verif As Boolean)
        Dim i, i_chap As Integer
        Dim DpParois, DpVentilo, DpPerso, DpEclairage, DpMachine, DpOuv_Porte, DpGeneriqueService, Dpi, DpRenouv_Air, RefPositif, RefNegatif, Congelation, RefPositif_i, RefNegatif_i, Congelation_i, TotalDpApport As Double
        Dim DpR_Degivrage, DpCordon_Porte, DpRuban_Soupape, DpCordon_Tuyauterie As Double
        'Calcul des déperditions des parois
        'Murs
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10 : rtf.Underline = True : i_chap = 1
        rtf.WriteString("2 - " & i_chap.ToString & " Déperditions par les parois pour 24h ") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        rtf.WriteString("Calcul déperditions parois verticales sur 24h ") : rtf.NewLine()
        For i = 1 To Murs.Count
            With Murs.Item(i - 1)
                Dpi = .Aire * .Uth * (.θext - Chbre_Froid.θint) * 3600 * 24 / 1000
                rtf.WriteString(" - Paroi " & i.ToString & ": θext = " & .θext.ToString("#0.0") & "°C - Dp = " & Dpi.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                DpParois += Dpi
            End With
        Next
        rtf.WriteString("Déperditions totales parois verticales sur 24h: " & DpParois.ToString("#,##0.0") & " KJ") : rtf.NewLine()
        'plafond
        rtf.WriteString("Calcul déperditions plafond sur 24h : ")
        With Plafond
            Dpi = .Aire * .Uth * (.θext - Chbre_Froid.θint) * 3600 * 24 / 1000
            rtf.WriteString("θext = " & .θext.ToString("#0.0") & "°C - Dp = " & Dpi.ToString("#,##0.0") & " KJ") : rtf.NewLine()
            DpParois += Dpi
        End With
        'sol
        rtf.WriteString("Calcul déperditions sol sur 24h : ")
        With Sol
            Dpi = .Aire * .Uth * (.θext - Chbre_Froid.θint) * 3600 * 24 / 1000
            rtf.WriteString("θext = " & .θext.ToString("#0.0") & "°C - Dp = " & Dpi.ToString("#,##0.0") & " KJ") : rtf.NewLine()
            DpParois += Dpi
        End With
        rtf.WriteString("Total des déperditions par les parois sur 24h: " & DpParois.ToString("#,##0.0") & " KJ") : rtf.NewLine() : rtf.NewLine()
        'Apports thermiques toute chambre froide
        rtf.FontSize = 10 : rtf.Underline = True : i_chap += 1
        rtf.WriteString("2 - " & i_chap.ToString & " Apports thermiques sur 24h") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        DpVentilo = 0 : DpPerso = 0 : DpEclairage = 0 : DpMachine = 0
        DpGeneriqueService = 0
        Select Case Chbre_Froid.ModeCalculApport
            Case 1 'Mode de calcul détaillé des apports
                With Chbre_Froid
                    'Ventilateurs
                    If .VentRatio > 0.1 Then
                        DpVentilo = Sol.Aire * .VentRatio * .GCheure * 3600 / 1000
                    Else
                        DpVentilo = .Ventnb * .VentPu * .GCheure * 3600 / 1000
                    End If
                    rtf.WriteString("- Ventilateurs: " & DpVentilo.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                    'Personnel 
                    DpPerso = .PersoNb * .PersoPu * .PersoTU * 3600 / 1000
                    rtf.WriteString("- Personnel: " & DpPerso.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                    'Eclairage
                    If .EclRatio > 0.1 Then
                        DpEclairage = .EclRatio * Sol.Aire * .GCheure * 3600 / 1000
                    Else
                        DpEclairage = .Eclnb * .EclPu * .PersoTU * 3600 / 1000
                    End If
                    rtf.WriteString("- Eclairage: " & DpEclairage.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                    'Machines
                    DpMachine = .MachinePt * .MachineFonctionnement * 3600 / 1000
                    rtf.WriteString("- Machines: " & DpMachine.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                    'Ouvertures de porte
                    rtf.WriteString("- Ouvertures de porte: mode de calcul basé sur la fréquence d'ouverture: ")
                    Select Case .Ouv_Porte
                        Case 1 ' faible
                            DpOuv_Porte = Aff.Freq_Faible * DpParois
                            rtf.WriteString("faible (= " & (Aff.Freq_Faible * 100).ToString("#") & "%) soit " & DpOuv_Porte.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                        Case 2 ' courant
                            DpOuv_Porte = Aff.Freq_normal * DpParois
                            rtf.WriteString("normale (= " & (Aff.Freq_normal * 100).ToString("#") & "%) soit " & DpOuv_Porte.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                        Case 3 ' fort
                            DpOuv_Porte = Aff.Freq_Fort * DpParois
                            rtf.WriteString("forte (= " & (Aff.Freq_Fort * 100).ToString("#") & "%) soit " & DpOuv_Porte.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                    End Select
                End With
            Case 0, 2 'Mode de calcul basé sur la notion de service
                rtf.WriteString("Sans objet - Voir notion de service au § Bilan ") : rtf.NewLine() 'Rien à faire à ce niveau - Voir directement le calcul global
        End Select
        rtf.NewLine()
        'Pertes par renouvellement d'air
        DpRenouv_Air = 0
        'Apports thermiques spécifiques aux chambres froides négatives
        If Chbre_Froid.θint < 0 Then
            DpR_Degivrage = 0 : DpCordon_Porte = 0 : DpRuban_Soupape = 0 : DpCordon_Tuyauterie = 0
            With Chbre_Froid
                'Résistances de dégivrage
                DpR_Degivrage = .RdegivragePt * .RdegivrageH * 3600 / 1000
                rtf.WriteString("- Résistances de dégivrage: " & DpR_Degivrage.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                'Cordon chauffant de porte
                DpCordon_Porte = .CordonChauffantPortePt * .CordonChauffantPorteH * 3600 / 1000
                rtf.WriteString("- Cordon chauffant de porte: " & DpCordon_Porte.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                'Rubans chauffant soupapes isopression
                DpRuban_Soupape = .RubChaufClapetPt * .RubChaufClapetH * 3600 / 1000
                rtf.WriteString("- Rubans chauffant soupapes isopression: " & DpRuban_Soupape.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                'Cordons chauffant des tuyauteries d'évacuation
                DpCordon_Tuyauterie = .CordonChauffanttuyauPt * .CordonChauffanttuyauH * 3600 / 1000
                rtf.WriteString("- Cordons chauffant des tuyauteries d'évacuation: " & DpCordon_Tuyauterie.ToString("#,##0.0") & " KJ") : rtf.NewLine()
            End With
        End If
        'Apports thermiques par les produits stockés
        rtf.FontSize = 10 : rtf.Underline = True : i_chap += 1
        rtf.WriteString("2 - " & i_chap.ToString & " Apports thermiques par les produits stockés sur 24h") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        RefPositif = 0 : RefNegatif = 0 : Congelation = 0
        For i = 1 To Matiere.Count
            RefPositif_i = 0 : RefNegatif_i = 0 : Congelation_i = 0
            With Matiere.Item(i - 1)
                rtf.WriteString("Produit n°" & i.ToString & " - " & .Nom & " :") : rtf.NewLine()
                If Chbre_Froid.θint < 0 Then
                    If .θp > 0 And .θpc > Chbre_Froid.θint Then
                        RefPositif_i = .mpcal * .Cpav * (.θp - .θpc)
                        rtf.WriteString("- avant congélation: " & RefPositif_i.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                        Congelation_i = .mpcal * .lc
                        rtf.WriteString("- congélation: " & Congelation_i.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                        RefPositif += RefPositif_i : Congelation += Congelation_i
                    ElseIf .θp > 0 And .θpc < Chbre_Froid.θint Then
                        RefPositif_i = .mpcal * .Cpav * (.θp - Chbre_Froid.θint)
                        rtf.WriteString("- avant congélation: " & RefPositif_i.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                        rtf.WriteString("- congélation: Sans Objet") : rtf.NewLine()
                    Else
                        rtf.WriteString("- avant congélation: Sans Objet") : rtf.NewLine()
                        rtf.WriteString("- congélation: Sans Objet") : rtf.NewLine()
                    End If
                    If .θpc > Chbre_Froid.θint Then
                        RefNegatif_i = .mpcal * .Cpap * (.θpc - Chbre_Froid.θint)  'la température du produit est inférieure à la température de la chambre froide
                        rtf.WriteString("- après congélation: " & RefNegatif_i.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                    Else
                        RefNegatif_i = 0
                        rtf.WriteString("- après congélation: Sans Objet") : rtf.NewLine()
                    End If
                    rtf.WriteString("Total refroidissement: " & (RefPositif_i + Congelation_i + RefNegatif_i).ToString("#,##0.0") & "KJ") : rtf.NewLine()
                    RefNegatif += RefNegatif_i
                Else
                    RefPositif_i = .mpcal * .Cpav * (.θp - Chbre_Froid.θint)
                    If .θp < Chbre_Froid.θint Then RefPositif_i = 0 'la température du produit est inférieure à la température de la chambre froide
                    rtf.WriteString("Refroidissement des denrées sur 24h: " & RefPositif_i.ToString("#,##0.0") & " KJ") : rtf.NewLine()
                    RefPositif += RefPositif_i
                End If
            End With
        Next
        If Matiere.Count > 1 Then
            If Chbre_Froid.θint < 0 Then
                rtf.WriteString("Pour l'ensemble des produits, refroidissement Total: " & (RefPositif + Congelation + RefNegatif).ToString("#,##0.0") & " KJ") : rtf.NewLine()
            Else
                rtf.WriteString("Refroidissement de l'ensemble des denrées sur 24h: " & RefPositif.ToString("#,##0.0") & " KJ") : rtf.NewLine()
            End If
        End If
        'Total déperditions et Apports thermiques par les produits stockés
        rtf.NewLine()
        rtf.FontSize = 10 : rtf.Underline = True : i_chap += 1
        rtf.WriteString("2 - " & i_chap.ToString & " Bilan") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()

        Select Case Chbre_Froid.ModeCalculApport
            Case 1 'Mode de calcul détaillé des apports
                TotalDpApport = DpParois + DpRenouv_Air + (DpVentilo + DpPerso + DpEclairage + DpMachine + DpOuv_Porte) + (RefPositif + RefNegatif + Congelation)
            Case 2
                TotalDpApport = DpParois + DpRenouv_Air + (RefPositif + RefNegatif + Congelation)
                rtf.WriteString("Mode de calcul basé sur la notion de service: ")
                Select Case Chbre_Froid.Service
                    Case 1 'service faible
                        DpGeneriqueService = Aff.Service_Faible * TotalDpApport
                        rtf.WriteString("Service faible (= " & (Aff.Service_Faible * 100).ToString("#") & "%) soit " & DpGeneriqueService.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                    Case 0, 2 'service courant
                        DpGeneriqueService = Aff.Service_Courant * DpParois
                        rtf.WriteString("Service courant (= " & (Aff.Service_Courant * 100).ToString("#") & "%) soit " & DpGeneriqueService.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                    Case 3 'service fort
                        DpGeneriqueService = Aff.Service_Fort * DpParois
                        rtf.WriteString("Service fort (= " & (Aff.Service_Fort * 100).ToString("#") & "%) soit " & DpGeneriqueService.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                End Select
                TotalDpApport += DpGeneriqueService
            Case Else
                TotalDpApport = DpParois + DpRenouv_Air + (RefPositif + RefNegatif + Congelation)
                rtf.WriteString("Mode de calcul basé sur la notion de service: ")
                'service courant
                DpGeneriqueService = Aff.Service_Courant * DpParois
                rtf.WriteString("Service courant (= " & (Aff.Service_Courant * 100).ToString("#") & "%) soit " & DpGeneriqueService.ToString("#,##0.0") & " KJ sur 24h.") : rtf.NewLine()
                TotalDpApport += DpGeneriqueService
        End Select
        rtf.WriteString("Total des déperditions et apports thermiques sur 24h: " & TotalDpApport.ToString("#,##0.0") & " KJ") : rtf.NewLine()
        rtf.WriteString("Temps de fonctionnement désiré du compresseur: " & Chbre_Froid.GCheure.ToString("#,##0.0") & " h") : rtf.NewLine()
        Chbre_Froid.GCpu = TotalDpApport / (Chbre_Froid.GCheure * 3600)
        rtf.WriteString("Puissance du groupe de condensation : " & Chbre_Froid.GCpu.ToString("#,##0.000") & " KW") : rtf.NewLine()
        rtf.WriteString("Puissance de l'évaporateur (prévoir une surpuissance de 5 à 10% de plus) : " & (1.05 * Chbre_Froid.GCpu).ToString("#,##0.000") & " KW à " & (1.1 * Chbre_Froid.GCpu).ToString("#,##0.000") & " KW") : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub

    ''' <summary> Module de calcul du coefficient de transmission surfacique</summary>
    ''' <param name="verif"> variable prenant la valeur False si une erreur bloquante s'est produite pendant le calcul</param>
    ''' <param name="Type_Calcul">=1 si paroi verticale, =2 si plafond, =3 si sol</param> 
    Public Sub Coef_U(ByVal Type_Calcul As Integer, ByVal nbcouche As Integer, ByVal ep() As Double, ByVal λ() As Double, ByRef Uv As Double, ByRef Unonv As Double, ByRef Verif As Boolean)
        Dim i As Integer
        Dim Ri As Double
        For i = 1 To nbcouche
            Ri += ep(i) / λ(i)
        Next
        With Aff
            Select Case Type_Calcul
                Case 1 'paroi verticale
                    Uv = 1 / ((1 / .hi) + (1 / .he_PV) + Ri)
                    Unonv = 1 / ((1 / .hi) + (1 / .he_P) + Ri)
                Case 2 'plafond
                    Uv = 1 / ((1 / .hi_bas) + (1 / .he_basV) + Ri)
                    Unonv = 1 / ((1 / .hi_bas) + (1 / .he_bas) + Ri)
                Case 3 'sol
                    Select Case Sol.Dallage
                        Case True 'If ChkbDallage.Checked = True Then Sol.Dallage = True Else Sol.Dallage = False
                            Uv = 0
                            Unonv = 1 / ((1 / .hi_haut) + Ri)
                        Case False
                            Uv = 1 / ((1 / .hi_haut) + (1 / .he_hautV) + Ri)
                            Unonv = 1 / ((1 / .hi_haut) + (1 / .he_haut) + Ri)
                    End Select

            End Select
        End With

    End Sub
End Module
