﻿Public Class ClsParoi

    Dim x_aire, x_Uth, x_θext As Double

    ''' <summary>
    ''' aire de la paroi- Unité: m2
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Aire As Double
        Get
            Aire = x_aire
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la surface de la paroi n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la l'aire de la paroi doit être positive.")
            Else
                x_aire = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' Coefficient de transmission thermique surfacique de la paroi- Unité: W/m².°K
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Uth As Double
        Get
            Uth = x_Uth
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la surface de la paroi n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la l'aire de la paroi doit être positive.")
            Else
                x_Uth = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' Température côté extérieur de la paroi- Unité: °C
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property θext As Double
        Get
            θext = x_θext
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la surface de la paroi n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la l'aire de la paroi doit être positive.")
            Else
                x_θext = value
            End If
        End Set
    End Property

End Class
