﻿Imports System.IO
Imports System.Math
Imports System.Xml.Serialization
Module General
    ''' <summary>Caractéristiques générales de l'affaire</summary>
    Public Aff As New ClsAffaire
    ''' <summary>Caractéristiques de la chambre froide</summary>
    Public Chbre_Froid As New ClsCh_Froid
    ''' <summary>Murs de la chambre froide</summary>
    Public Murs As New List(Of ClsParoi)
    ''' <summary>Plafond de la chambre froide</summary>
    Public Plafond As New ClsParoi
    ''' <summary>sol de la chambre froide</summary>
    Public Sol As New ClsParoiSol
    ''' <summary>caractéristiques de tous les produits stockés dans la chambre froide</summary>
    Public Matiere As New List(Of ClsProduit)
    ''' <summary>Liste générique de produits pouvant être stockés et dont les caractéristiques ont été déjà renseignées dans le logiciel</summary>
    Public Matieres_Prestockees As New List(Of ClsProduit)

    Public Function checkAscii(ByVal keyAscii As Integer, ByVal Positif As Boolean) As Integer
        checkAscii = Abs(keyAscii)
        If keyAscii < 0 Then
            If Abs(keyAscii) = 44 Then
                Exit Function
            End If
        End If
        If Abs(keyAscii) = 8 Then Exit Function ' touche del utilisable
        If Abs(keyAscii) = 44 Then Exit Function 'touche +
        If Abs(keyAscii) = 45 AndAlso Positif = False Then Exit Function 'touche -
        If Abs(keyAscii) < 48 Or Abs(keyAscii) > 57 Then checkAscii = 0
    End Function
    ''' <summary>
    '''Programme de gestion d'appui des touches 
    ''' </summary>
    ''' <param name="ee">touche appuyée</param>
    ''' <param name="text1">textbox adressé</param>
    '''  <param name="positif">vrai si le nombre est positif, empèche la mise en place d'un - devant le nombre</param>
    ''' <param name="entier"> indique que le textbox est un entier</param>
    Public Sub Gestion_Keypress(ByRef ee As System.Windows.Forms.KeyPressEventArgs, ByVal text1 As System.Windows.Forms.TextBox,
                                ByVal positif As Boolean, ByVal entier As Boolean)
        Dim keyAscii As Integer
        keyAscii = Asc(ee.KeyChar)
        If text1.SelectionLength = text1.Text.Length Then
            text1.Clear()
        End If
        If keyAscii = Asc(".") Then
            If entier = False Then
                text1.Text = text1.Text + ","
                text1.SelectionStart = Len(text1.Text) + 1
            End If
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc(",") And entier = True Then
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("&") Then
            text1.Text = text1.Text + "1"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("é") Then
            text1.Text = text1.Text + "2"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = 34 Then ' code "
            text1.Text = text1.Text + "3"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("'") Then
            text1.Text = text1.Text + "4"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("(") Then
            text1.Text = text1.Text + "5"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If positif = True Then 'seulement si la valeur >0
            If keyAscii = Asc("-") Then
                text1.Text = text1.Text + "6"
                text1.SelectionStart = Len(text1.Text) + 1
                ee.Handled = True
                Exit Sub
            End If
        End If
        If keyAscii = Asc("è") Then
            text1.Text = text1.Text + "7"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("_") Then
            text1.Text = text1.Text + "8"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("ç") Then
            text1.Text = text1.Text + "9"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("à") Then
            text1.Text = text1.Text + "0"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        keyAscii = checkAscii(keyAscii, positif)
        If keyAscii = 0 Then ee.Handled = True
    End Sub
    Public Sub Variables_generales()

        'Inscrit en dur dans le logiciel dans le cas d'une réinitialisation malheureuse ............
        With Aff
            .msgData = Directory.GetCurrentDirectory.ToString() & "\Data"
            .msgResult = Directory.GetCurrentDirectory.ToString() & "\Resultat"
            .Redacteur = "LeFux_Ingenierie"
            .Chantier = "Chambre_Froide_1"
            '.Lecteur_Pdf = "acroRd32.exe" 'Acrobat reader
            .i_result = 1 : .i_data = 1 : .Editeur = 1
            .Service_Faible = 0.1 : .Service_Courant = 0.15 : .Service_Fort = 0.25
            .Freq_Faible = 0.1 : .Freq_normal = 0.15 : .Freq_Fort = 0.2
            .he_hautV = 25 : .he_haut = 11 : .he_PV = 25 : .he_P = 8 : .he_basV = 25 : .he_bas = 6
            .hi_haut = 20 : .hi = 17 : .hi_bas = 20
        End With
        'Produits stockés
        Dim P1 As New ClsProduit
        Matieres_Prestockees.Clear()
        P1.Nom = "Générique_Viandes" : P1.Cpav = 3.225 : P1.Cpap = 1.715 : P1.lc = 238.55 : P1.ProdUnite = 0 : P1.mp = 10 : P1.dp = 1 : P1.θp = 0
        Matieres_Prestockees.Add(P1)
        P1 = New ClsProduit
        P1.Nom = "Générique_Liquides" : P1.Cpav = 3.77 : P1.Cpap = 0 : P1.lc = 0 : P1.ProdUnite = 0 : P1.mp = 10 : P1.dp = 1 : P1.θp = 0
        Matieres_Prestockees.Add(P1)
        P1 = New ClsProduit
        P1.Nom = "Générique_Laitage" : P1.Cpav = 3.64 : P1.Cpap = 0 : P1.lc = 0 : P1.ProdUnite = 0 : P1.mp = 10 : P1.dp = 1 : P1.θp = 0
        Matieres_Prestockees.Add(P1)
        P1 = New ClsProduit
        P1.Nom = "Générique_Denrées" : P1.Cpav = 3.64 : P1.Cpap = 0 : P1.lc = 0 : P1.ProdUnite = 0 : P1.mp = 10 : P1.dp = 1 : P1.θp = 0
        Matieres_Prestockees.Add(P1)
        P1 = New ClsProduit
        P1.Nom = "Autre" : P1.Cpav = 0 : P1.Cpap = 0 : P1.lc = 0 : P1.mp = 0 : P1.ProdUnite = 10 : P1.dp = 1 : P1.θp = 0
        Matieres_Prestockees.Add(P1)
    End Sub
    ''' <summary>Programme de gestion des entrées dans les textbox</summary>
    '''  <param name="e">ByVal e As System.Windows.Forms.TextBox</param>
    ''' <param name="ep1">ByRef ep1 As System.Windows.Forms.ErrorProvider</param>
    Public Function gestionderreur(ByVal e As System.Windows.Forms.TextBox, ByRef ep1 As System.Windows.Forms.ErrorProvider) As Boolean
        Try
            If e.Text = "" Then
                ep1.SetError(e, "le champ n'a pas été renseigné!!")
                gestionderreur = False
            ElseIf Not IsNumeric(CDbl(e.Text)) Then  '
                ep1.SetError(e, "le champ n'est pas une valeur numérique !!")
                gestionderreur = False
            Else
                ep1.SetError(e, "") ' Clear the error.
                gestionderreur = True
            End If
        Catch ex As Exception
            ep1.SetError(e, ex.Message)
            gestionderreur = False
        End Try
    End Function
    Public Function Mise_en_Forme(ByVal Toto As String) As String
        Dim toti As String
        toti = Replace(Toto, "/", "_")
        Toto = Replace(toti, " ", "_")
        toti = Replace(Toto, ":", "_")
        Mise_en_Forme = toti
    End Function

    Public Sub Lecture_Fichier_Cfg_ini(ByVal filename As String, ByRef Verif As Boolean)
        Dim myStreamReader As StreamReader
        Dim toto, titi(6) As String ', tutu
        Verif = True
        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            toto = myStreamReader.ReadLine 'ligne de commentaire
            With Aff
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .Redacteur = CStr(titi(1))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .Chantier = CStr(titi(1))
                toto = myStreamReader.ReadLine  'ligne suivante
                .msgResult = toto
                toto = myStreamReader.ReadLine   'ligne suivante
                .msgData = toto
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .i_result = CInt(titi(1)) : .i_data = CInt(titi(2)) : .Editeur = CInt(titi(3))
                toto = myStreamReader.ReadLine 'ligne de commentaire
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .Service_Faible = CDbl(titi(1)) : .Service_Courant = CDbl(titi(2)) : .Service_Fort = CDbl(titi(3))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .Freq_Faible = CDbl(titi(1)) : .Freq_normal = CDbl(titi(2)) : .Freq_Fort = CDbl(titi(3))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .he_hautV = CDbl(titi(1)) : .he_haut = CDbl(titi(2)) : .he_PV = CDbl(titi(3)) : .he_P = CDbl(titi(4)) : .he_basV = CDbl(titi(5)) : .he_bas = CDbl(titi(6))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                .hi_haut = CDbl(titi(1)) : .hi = CDbl(titi(2)) : .hi_bas = CDbl(titi(3))
            End With

        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier de configuration: " & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Module lecture fichier configuration",
                      MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
            Verif = False
        Finally
            Erase titi
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(15), i, j, position As Integer
        Dim tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub

    Public Sub Entête_Note_de_calcul(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        rtf.WriteStartGroup()
        rtf.NewParagraph(To_Rtf.RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Bilan frigorifique d'une chambre froide")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 9 : rtf.Underline = False : rtf.NewParagraph(To_Rtf.RtfAnsiTextWriter.Align.Left)
        Dim dt As New DateTime
        dt = DateTime.Now
        rtf.WriteString("Note de calcul du ") : rtf.WriteString(dt.ToString("dddd d MMMM yyyy à HH:mm:ss")) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : Calcul frigorifique version " & My.Application.Info.Version.ToString & "   2021 - " & DateTime.Now.Year.ToString) : rtf.NewLine()
        '--> § Hypothèses
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses") : rtf.Bold = False
        rtf.FontSize = 9 : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        With Chbre_Froid
            rtf.WriteString("Référence de la chambre froide calculée: " & .Refence) : rtf.NewLine()
            rtf.WriteString("Température intérieure moyenne de la chambre froide: " & .θint.ToString("#0.0") & "°C") : rtf.NewLine()
            rtf.WriteString("Humidité relative: entre " & .Hrbas.ToString("#0.0") & "% et " & .Hrhaut.ToString("#0.0") & "%") : rtf.NewLine()
            rtf.WriteString("Temps de fonctionnement souhaité du groupe de condensation: " & .GCheure.ToString("#,##0.0") & "h") : rtf.NewLine()
        End With
        rtf.WriteString("Parois comprenant:") : rtf.NewLine()
        rtf.WriteString(" - sol: surface =" & Sol.Aire.ToString("#0.00") & " m² - coef U = " & Sol.Uth.ToString("#0.000") & " W/m²°K - θ externe = " & Sol.θext.ToString("#0.0") & " °C.") : rtf.NewLine()
        For i = 1 To Murs.Count
            rtf.WriteString(" - mur (" & i.ToString & "): surface =" & Murs(i - 1).Aire.ToString("#0.00") & " m² - coef U = " & Murs(i - 1).Uth.ToString("#0.000") & " W/m²°K - θ externe = " & Murs(i - 1).θext.ToString("#0.0") & " °C.") : rtf.NewLine()
        Next
        rtf.WriteString(" - plafond: surface =" & Plafond.Aire.ToString("#0.00") & " m² - coef U = " & Plafond.Uth.ToString("#0.000") & " W/m²°K - θ externe = " & Plafond.θext.ToString("#0.0") & " °C.") : rtf.NewLine()
        rtf.WriteString("Produits stockés:") : rtf.NewLine()
        For Each mat In Matiere
            rtf.WriteString("Quantité moyenne de " & mat.Nom & " introduit par jour dans la chambre froide :" & mat.mpcal.ToString("#0.000") & " Kg/Jour à une température de " & mat.θp.ToString("#0.0") & " °C") : rtf.NewLine()
        Next

        '--> § Calcul
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("2 - Calcul") : rtf.Bold = False
        rtf.FontSize = 10 : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Function Mise_en_Forme_date(ByVal Toto As String) As String
        Dim toti As String
        toti = Replace(Toto, "/", "_")
        Toto = Replace(toti, " ", "_")
        toti = Replace(Toto, ":", "_")
        Mise_en_Forme_date = toti
    End Function
#Region " Code de lecture et d'écriture du fichier de données "

#Region "Sérialization"
    ''' <summary>Routine sauvegardant les données objet par sérialization </summary>
    Public Sub SerializeData()
        Dim Fichier_Chbre_Froid As String = String.Empty 'Public Chbre_Froid As New ClsCh_Froid
        Dim Fichier_Murs As String = String.Empty 'Public Murs As New List(Of ClsParoi)
        Dim Fichier_Plafond As String = String.Empty  'Public Plafond As New ClsParoi
        Dim Fichier_Sol As String = String.Empty  'Public Sol As New ClsParoiSol
        Dim Fichier_Matiere As String = String.Empty    'Public Matiere As New ClsProduit
        Dim Fichier_Affaire As String = String.Empty 'Public Aff As New ClsAffaire

        Dim myStreamWriter As StreamWriter = Nothing
        Try
            myStreamWriter = File.CreateText(Aff.FileName)
            myStreamWriter.WriteLine("Chambre froide - Fichiers de sauvegarde de l'affaire")
            Fichier_Chbre_Froid = "Fichier_Chbre_Froid_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Chbre_Froid)
            Fichier_Murs = "Fichier_Murs_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Murs)
            Fichier_Plafond = "Fichier_Plafond_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Plafond)
            Fichier_Sol = "Fichier_Sol_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Sol)
            Fichier_Matiere = "Fichier_Matiere_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Matiere)
            Fichier_Affaire = "Fichier_Affaire_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Affaire)
            myStreamWriter.Flush()
        Catch exc As Exception
            MessageBox.Show("Le fichier de sauvegarde ne peut être crée." + Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
              "dans le répertoire indiqué." + Environment.NewLine + Environment.NewLine + "Erreur: " + exc.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            ' fermer le fichier si pas de création possible
            If myStreamWriter IsNot Nothing Then myStreamWriter.Close()
        End Try
        'Sérialise les objets
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Chbre_Froid & ".xml", Chbre_Froid)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Murs & ".xml", Murs)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Plafond & ".xml", Plafond)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Sol & ".xml", Sol)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Matiere & ".xml", Matiere)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Affaire & ".xml", Aff)

    End Sub
    Private Sub SerializeSysKeys(ByVal Path As String, ByVal Objet As Object)
        Try
            Call SaveXmlData(Path, Objet)
        Catch ex As Exception
            MessageBox.Show("Problème de sérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub SaveXmlData(ByVal Path As String, ByVal Objet As Object)
        Dim Type As Type = Objet.GetType
        Dim Serializeur As New XmlSerializer(Type)
        Dim Fi As New FileInfo(Path)
        If Fi.Directory.Exists = False Then System.IO.Directory.CreateDirectory(Fi.DirectoryName)
        'Sérialization
        Using fs As New FileStream(Path, FileMode.Create, FileAccess.Write)
            Serializeur.Serialize(fs, Objet)
            fs.Close()
        End Using
    End Sub
#End Region

#Region "Déserialization"
    ''' <summary>Routine lisant et affectant les données objet par sauvegardées par sérialization </summary>
    Public Sub DeSerializeData(ByVal Racine As String, ByRef Verif As Boolean)
        Dim toto, titi(20) As String
        Dim Fichier_Chbre_Froid As String = String.Empty 'Public Chbre_Froid As New ClsCh_Froid
        Dim Fichier_Murs As String = String.Empty 'Public Murs As New List(Of ClsParoi)
        Dim Fichier_Plafond As String = String.Empty  'Public Plafond As New ClsParoi
        Dim Fichier_Sol As String = String.Empty  'Public Sol As New ClsParoiSol
        Dim Fichier_Matiere As String = String.Empty    'Public Matiere As New ClsProduit
        Dim Fichier_Affaire As String = String.Empty 'Public Aff As New ClsAffaire
        Dim myStreamReader As StreamReader = Nothing

        Try
            myStreamReader = File.OpenText(Aff.FileName)
            toto = myStreamReader.ReadLine 'barre de titre
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Chbre_Froid = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Murs = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Plafond = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Sol = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Matiere = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Affaire = CStr(titi(1))
        Catch exc As Exception
            MessageBox.Show("Le fichier de sauvegarde ne peut être lu." + Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
              "dans le répertoire indiqué." + Environment.NewLine + Environment.NewLine + "Erreur: " + exc.Message, "Lecture des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            If myStreamReader IsNot Nothing Then myStreamReader.Close() 'fermer le fichier si pas de création possible
        End Try
        'DéSérialise les objets
        If Racine + "\" <> Aff.msgData Then
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Chbre_Froid & ".xml", Chbre_Froid, 1)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Murs & ".xml", Murs, 2)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Plafond & ".xml", Plafond, 3)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Sol & ".xml", Sol, 4)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Matiere & ".xml", Matiere, 5)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Affaire & ".xml", Aff, 6)
        Else
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Chbre_Froid & ".xml", Chbre_Froid, 1)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Murs & ".xml", Murs, 2)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Plafond & ".xml", Plafond, 3)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Sol & ".xml", Sol, 4)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Matiere & ".xml", Matiere, 5)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Affaire & ".xml", Aff, 6)
        End If

    End Sub
    Private Sub DeSerializeSysKeys(ByVal Path As String, ByVal Objet As Object, ByVal i As Integer)
        ' Try
        Call LoadXmlData(Path, Objet)
        Select Case i
            Case 1
                Chbre_Froid = CType(Objet, ClsCh_Froid)   'Public Chbre_Froid As New ClsCh_Froid
            Case 2
                Murs = CType(Objet, List(Of ClsParoi))'Public Murs As New List(Of ClsParoi)
            Case 3
                Plafond = CType(Objet, ClsParoi)'Public Plafond As New ClsParoi
            Case 4
                Sol = CType(Objet, ClsParoiSol)'Public Sol As New ClsParoiSol
            Case 5
                Matiere = CType(Objet, List(Of ClsProduit))'Public Matiere As New ClsProduit
            Case 6
                Aff = CType(Objet, ClsAffaire)
        End Select

        'Catch ex As Exception
        '    MessageBox.Show("Problème de Désérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Module DeSerializeSysKeys", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        'End Try
    End Sub
    Private Sub LoadXmlData(ByVal Path As String, ByRef Objet As Object)

        ' Try
        Dim Type As Type = Objet.GetType
        Dim Serializeur As New XmlSerializer(Type)
        Dim Fi As New FileInfo(Path)
        If Fi.Directory.Exists = False Then System.IO.Directory.CreateDirectory(Fi.DirectoryName)
        'Sérialization
        Using fs As New FileStream(Path, FileMode.Open, FileAccess.Read)
            Objet = Serializeur.Deserialize(fs)
            fs.Close()
        End Using
        'Catch ex As Exception
        '    MessageBox.Show("Problème de Désérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Module LoadXmlData", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        'End Try
    End Sub
#End Region
    Private Sub Lecture_chaine(ByVal toto As String, ByRef titi() As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel)
        Dim blanc(20), i, j, position As Integer
        Dim tutu As String

        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        If titi(1) = "'" Then Exit Sub 'cette chaine correspond à un commentaire, sortie du programme
        'supprime tout commentaire dans la chaine
        position = InStr(1, toto, "'")
        If position <> 0 Then
            toto = Microsoft.VisualBasic.Left(toto, position - 1)
            toto = Trim(toto)
        End If
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
#End Region
End Module
