﻿Imports System.IO
Public Class frmChFroide
    Public Type_Calcul As Integer '=1 si paroi latérale, =2 si plafond, =3 si sol

    Private Sub BtnCalcul_Click(sender As Object, e As EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Try
            Call Lecture_Onglets(Verif)
            If Verif = False Then
                MessageBox.Show("Erreur lors de la lecture des données dans les onglets", "frmChFroide Sub Lecture_Onglets", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            '----> Initialisation de la note de calcul
            'writer de sortie du RTF
            Dim sw As New System.IO.StringWriter
            'crée un writer de RTF avec une police par défaut
            Dim rtf As New To_Rtf.RtfAnsiTextWriter(sw, New Font(FontFamily.GenericSerif, 12, FontStyle.Regular))
            Dim rtff As String = String.Empty
            Dim Note_de_calcul As String = String.Empty
            Call Entête_Note_de_calcul(rtf)
            '----> Lancement du calcul
            Call Bilan_Frigorifique(rtf, Verif)
            If Verif = False Then Exit Sub
            'génère le RTF complet
            Note_de_calcul = "Ndc_ChFroid_" & Mise_en_Forme(CStr(DateTime.Now)) & ".rtf"
            Aff.FileNoteCalcul = Aff.msgResult & "\" & Note_de_calcul
            rtf.Generate() : rtff = sw.ToString
            File.WriteAllText(Aff.FileNoteCalcul, rtff)
            MessageBox.Show("Calcul terminé!" & Environment.NewLine & "Cliquez sur le bouton Editer pour afficher la note de calcul", "Dimensionnement chambre froide", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show("Erreur" & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Dimensionnement chambre froide", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Private Sub Lecture_Onglets(ByRef Verif As Boolean)
        Dim total As Integer = 1
        Dim i As Integer
        'Onglet caractéristiques générales
        With Chbre_Froid
            .Refence = TxtRefence.Text
            If gestionderreur(TxtTemperature, EP1) = True Then .θint = CDbl(TxtTemperature.Text) Else Verif = False
            If RbtnChNegative.Checked = True Then .θint = - .θint
            If gestionderreur(TxtHrBas, EP1) = True Then .Hrbas = CDbl(TxtHrBas.Text) Else Verif = False
            If gestionderreur(TxtHrHaut, EP1) = True Then .Hrhaut = CDbl(TxtHrHaut.Text) Else Verif = False
            If gestionderreur(TxtGroupCondensationNbHeure, EP1) = True Then .GCheure = CDbl(TxtGroupCondensationNbHeure.Text) Else Verif = False
            If RbtnApportThermique_Calcul.Checked = True Then .ModeCalculApport = 1 'Calcul détaillé
            If RbtnApportThermique_Service.Checked = True Then .ModeCalculApport = 2 'par service
            i = LbService.SelectedIndex
            Select Case i
                Case 0 'Faible
                    .Service = 1
                Case 1 'Normal
                    .Service = 2
                Case 2 'Fort
                    .Service = 3
            End Select
        End With
        'onglet Parois
        '-->Plafond
        If gestionderreur(TxtPlafAire, EP1) = True Then Plafond.Aire = CDbl(TxtPlafAire.Text) Else Verif = False
        If gestionderreur(TxtPlafU, EP1) = True Then Plafond.Uth = CDbl(TxtPlafU.Text) Else Verif = False
        If gestionderreur(TxtPlafTe, EP1) = True Then Plafond.θext = CDbl(TxtPlafTe.Text) Else Verif = False
        '--> Sol
        If gestionderreur(TxtSolAire, EP1) = True Then Sol.Aire = CDbl(TxtSolAire.Text) Else Verif = False
        If gestionderreur(TxtSolU, EP1) = True Then Sol.Uth = CDbl(TxtSolU.Text) Else Verif = False
        If gestionderreur(TxtSolTe, EP1) = True Then Sol.θext = CDbl(TxtSolTe.Text) Else Verif = False
        If ChkbDallage.Checked = True Then Sol.Dallage = True Else Sol.Dallage = False
        '-->Mur
        If gestionderreur(TxtTotalParois, EP1) = True Then Chbre_Froid.MursNb = CInt(TxtTotalParois.Text) Else Verif = False
        i = CInt(LblnbParois.Text)   'car la collection commence à 0
        Call LecturePv(i, Verif)
        If Verif = False Then
            MessageBox.Show("Erreur lors de la lecture des données pour la paroi verticale " & i.ToString, "frmChFroide Sub LecturePv", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If
        If Chbre_Froid.MursNb <> Murs.Count Then
            MessageBox.Show("Le nombre de murs indiqués (" & Chbre_Froid.MursNb.ToString & ") est différent de celui du nombre de murs renseignés(" & Murs.Count.ToString & ")! ", "Onglet Parois",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False : Exit Sub
        End If
        'Onglet "Apports thermiques" toutes chambres froides
        With Chbre_Froid
            '--> Ventilateur
            .VentRatio = 0 : .Ventnb = 0 : .VentPu = 0
            If RbtnVentilateurRatio.Checked = True Then
                If gestionderreur(TxtVentRatio, EP1) = True Then .VentRatio = CDbl(TxtVentRatio.Text) Else Verif = False
            End If
            If RbtnVentilateurNb.Checked = True Then
                If gestionderreur(TxtVentNb, EP1) = True Then .Ventnb = CInt(TxtVentNb.Text) Else Verif = False
                If gestionderreur(TxtVentPu, EP1) = True Then .VentPu = CDbl(TxtVentPu.Text) Else Verif = False
            End If
            '-->Personnel
            If gestionderreur(TxtPersoNb, EP1) = True Then .PersoNb = CInt(TxtPersoNb.Text) Else Verif = False
            If gestionderreur(TxtPersoTemps, EP1) = True Then .PersoTU = CDbl(TxtPersoTemps.Text) Else Verif = False
            If gestionderreur(TxtPersoPu, EP1) = True Then .PersoPu = CDbl(TxtPersoPu.Text) Else Verif = False
            '-->Eclairage
            .EclRatio = 0 : .Eclnb = 0 : .EclPu = 0
            If RbtnEclRatio.Checked = True Then
                If gestionderreur(TxtEclRatio, EP1) = True Then .EclRatio = CDbl(TxtEclRatio.Text) Else Verif = False
                If gestionderreur(TxtEclRatioTemp, EP1) = True Then .EclTemps = CDbl(TxtEclRatioTemp.Text) Else Verif = False
            End If
            If RbtnEclNb.Checked = True Then
                If gestionderreur(TxtEclNb, EP1) = True Then .Eclnb = CInt(TxtEclNb.Text) Else Verif = False
                If gestionderreur(TxtEclPu, EP1) = True Then .EclPu = CDbl(TxtEclPu.Text) Else Verif = False
                If gestionderreur(TxtEclTemp, EP1) = True Then .EclTemps = CDbl(TxtEclTemp.Text) Else Verif = False
            End If
            '--> Machines
            If gestionderreur(TxtMachinePt, EP1) = True Then .MachinePt = CDbl(TxtMachinePt.Text) Else Verif = False
            If gestionderreur(TxtMachineTemps, EP1) = True Then .MachineFonctionnement = CDbl(TxtMachineTemps.Text) Else Verif = False
            '--> Ouvertures de porte
            i = LBoxFrequencePorte.SelectedIndex
            Select Case i
                Case 0 'Faible
                    .Ouv_Porte = 1
                Case 1 'Normal
                    .Ouv_Porte = 2
                Case 2 'Fort
                    .Ouv_Porte = 3
            End Select
        End With

        If RbtnChNegative.Checked = True Then
            'Onglet "Apports thermiques" chambres froides négatives exclusivement
            With Chbre_Froid
                '--> Résistance de dégivrage
                If gestionderreur(TxtDegivragePu, EP1) = True Then .RdegivragePt = CDbl(TxtDegivragePu.Text) Else Verif = False
                If gestionderreur(TxtDegivrageH, EP1) = True Then .RdegivrageH = CDbl(TxtDegivrageH.Text) Else Verif = False
                '-->Cordon chauffant de porte
                If gestionderreur(TxtCordonPortePu, EP1) = True Then .CordonChauffantPortePt = CDbl(TxtCordonPortePu.Text) Else Verif = False
                If gestionderreur(TxtCordonPorteH, EP1) = True Then .CordonChauffantPorteH = CDbl(TxtCordonPorteH.Text) Else Verif = False
                '-->Ruban chauffant clapet isopression
                If gestionderreur(TxtRubanClapetPu, EP1) = True Then .RubChaufClapetPt = CDbl(TxtRubanClapetPu.Text) Else Verif = False
                If gestionderreur(TxtRubanClapetH, EP1) = True Then .RubChaufClapetH = CDbl(TxtRubanClapetH.Text) Else Verif = False
                '--> Cordons chauffant tuyauteries évacuation
                If gestionderreur(TxtCordonTuyauteriePu, EP1) = True Then .CordonChauffanttuyauPt = CDbl(TxtCordonTuyauteriePu.Text) Else Verif = False
                If gestionderreur(TxtCordonTuyauterieH, EP1) = True Then .CordonChauffanttuyauH = CDbl(TxtCordonTuyauterieH.Text) Else Verif = False
            End With
        End If

        'onglet "Produits stockés"
        i = CInt(LblProdNum.Text)    'car la collection commence à 0
        Call LectureProduits(i, Verif)
    End Sub

    Private Sub Affichage_Onglets()
        Dim i As Integer
        'Onglet caractéristiques générales
        With Chbre_Froid
            TxtRefence.Text = .Refence
            TxtTemperature.Text = .θint.ToString("#0.0")
            If .θint < 0 Then LblSigne.Text = "-" Else LblSigne.Text = "+"
            TxtHrBas.Text = .Hrbas.ToString("#0.0")
            TxtHrHaut.Text = .Hrhaut.ToString("#0.0")
            TxtGroupCondensationNbHeure.Text = .GCheure.ToString("#0.0")
            Select Case .ModeCalculApport
                Case 1 'Calcul détaillé
                    RbtnApportThermique_Calcul.Checked = True
                Case 2 'par service
                    RbtnApportThermique_Service.Checked = True
                    Select Case .Service
                        Case 1 'Faible
                            LbService.SetSelected(0, True)
                        Case 2 'Normal
                            LbService.SetSelected(1, True)
                        Case 3 'Fort
                            LbService.SetSelected(2, True)
                    End Select
            End Select
        End With
        'onglet Parois
        '-->Plafond
        TxtPlafAire.Text = Plafond.Aire.ToString("#0.00")
        TxtPlafU.Text = Plafond.Uth.ToString("#0.000")
        TxtPlafTe.Text = Plafond.θext.ToString("#0.0")
        '--> Sol
        TxtSolAire.Text = Sol.Aire.ToString("#0.00")
        TxtSolU.Text = Sol.Uth.ToString("#0.000")
        TxtSolTe.Text = Sol.θext.ToString("#0.0")
        If Sol.Dallage = True Then ChkbDallage.Checked = True Else ChkbDallage.Checked = False
        '-->Mur
        If Murs.Count >= 1 Then
            TxtTotalParois.Text = Chbre_Froid.MursNb.ToString("#")
            LblnbParois.Text = "1" 'car la collection commence à 0
            Call AffichageMurs(1)
        Else
            TxtLatAire.Text = ""
            TxtLatU.Text = ""
            TxtLatTe.Text = ""
        End If
        'Onglet "Apports thermiques" 
        With Chbre_Froid
            '--> Ventilateur
            If .Ventnb = 0 Then
                'calcul sur le ratio ou pas de calcul du tout
                RbtnVentilateurRatio.Checked = True
                TxtVentRatio.Text = .VentRatio.ToString("#0.0")
            Else
                RbtnVentilateurNb.Checked = True
                TxtVentNb.Text = .Ventnb.ToString("#0")
                TxtVentPu.Text = .VentPu.ToString("#0.00")
            End If
            '-->Personnel
            TxtPersoNb.Text = .PersoNb.ToString("#0")
            TxtPersoTemps.Text = .PersoTU.ToString("#0.0")
            TxtPersoPu.Text = .PersoPu.ToString("#0.0")
            '-->Eclairage
            If .Eclnb = 0 Then
                RbtnEclRatio.Checked = True
                TxtEclRatio.Text = .EclRatio.ToString("#0.00")
                TxtEclRatioTemp.Text = .EclTemps.ToString("#0.00")
            Else
                RbtnEclNb.Checked = True
                TxtEclNb.Text = .Eclnb.ToString("#0")
                TxtEclPu.Text = .EclPu.ToString("#0.00")
                TxtEclTemp.Text = .EclTemps.ToString("#0.00")
            End If
            '--> Machines
            TxtMachinePt.Text = .MachinePt.ToString("#0.0")
            TxtMachineTemps.Text = .MachineFonctionnement.ToString("#0.0")
            '--> ouvertures de porte

        End With

        ' If RbtnChNegative.Checked = True Then
        'Onglet "Apports thermiques" chambres froides négatives exclusivement
        With Chbre_Froid
            '--> Résistance de dégivrage
            TxtDegivragePu.Text = .RdegivragePt.ToString("#0.0")
            TxtDegivrageH.Text = .RdegivrageH.ToString("#0.0")
            '-->Cordon chauffant de porte
            TxtCordonPortePu.Text = .CordonChauffantPortePt.ToString("#0.0")
            TxtCordonPorteH.Text = .CordonChauffantPorteH.ToString("#0.0")
            '-->Ruban chauffant clapet isopression
            TxtRubanClapetPu.Text = .RubChaufClapetPt.ToString("#0.0")
            TxtRubanClapetH.Text = .RubChaufClapetH.ToString("#0.0")
            '--> Cordons chauffant tuyauteries évacuation
            TxtCordonTuyauteriePu.Text = .CordonChauffanttuyauPt.ToString("#0.0")
            TxtCordonTuyauterieH.Text = .CordonChauffanttuyauH.ToString("#0.0")
        End With
        ' End If
        'onglets Produits stockés
        i = CInt(LblProdNum.Text) 'car la collection commence à 0
        If Matiere.Count > 0 AndAlso i <= Matiere.Count Then Call AffichageProduits(i)
    End Sub

#Region "Onglet Caractéristiques générales"
    Private Sub RbtnChPositive_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnChPositive.CheckedChanged
        If RbtnChPositive.Checked = True Then
            LblSigne.Text = "+"
            'Onglet 4
            TxtDegivragePu.Text = "0" : TxtDegivragePu.Enabled = False : TxtDegivrageH.Text = "0" : TxtDegivrageH.Enabled = False
            TxtCordonPortePu.Text = "0" : TxtCordonPortePu.Enabled = False : TxtCordonPorteH.Text = "0" : TxtCordonPorteH.Enabled = False
            TxtRubanClapetPu.Text = "0" : TxtRubanClapetPu.Enabled = False : TxtRubanClapetH.Text = "0" : TxtRubanClapetH.Enabled = False
            TxtCordonTuyauteriePu.Text = "0" : TxtCordonTuyauteriePu.Enabled = False : TxtCordonTuyauterieH.Text = "0" : TxtCordonTuyauterieH.Enabled = False
            'Onglet 5
            lblCpap.Visible = False : TxtCpap.Visible = False : lblUCpap.Visible = False
            lblLc.Visible = False : Txtlc.Visible = False : lblUlc.Visible = False
            lblProdTempCongel.Visible = False : TxtProdTempCongel.Visible = False : lblUProdTempCongel.Visible = False
        End If
    End Sub

    Private Sub RbtnChNegative_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnChNegative.CheckedChanged
        If RbtnChNegative.Checked = True Then
            LblSigne.Text = "-"
            'Onglet 4
            TxtDegivragePu.Enabled = True : TxtDegivrageH.Enabled = True
            TxtCordonPortePu.Enabled = True : TxtCordonPorteH.Enabled = True
            TxtRubanClapetPu.Enabled = True : TxtRubanClapetH.Enabled = True
            TxtCordonTuyauteriePu.Enabled = True : TxtCordonTuyauterieH.Enabled = True
            'Onglet 5
            lblCpap.Visible = True : TxtCpap.Visible = True : lblUCpap.Visible = True
            lblLc.Visible = True : Txtlc.Visible = True : lblUlc.Visible = True
            lblProdTempCongel.Visible = True : TxtProdTempCongel.Visible = True : lblUProdTempCongel.Visible = True
        End If
    End Sub
    Private Sub RbtnApportThermique_Calcul_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnApportThermique_Calcul.CheckedChanged
        If RbtnApportThermique_Calcul.Checked = True Then
            LbService.Visible = False : BtnHlpService.Visible = False
        End If
    End Sub

    Private Sub RbtnApportThermique_Service_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnApportThermique_Service.CheckedChanged
        If RbtnApportThermique_Service.Checked = True Then
            LbService.Visible = True : BtnHlpService.Visible = True
        End If
    End Sub
#End Region

#Region "Onglet Parois"
    Private Sub BtnUlat_Click(sender As Object, e As EventArgs) Handles BtnUlat.Click
        Type_Calcul = 1
        frmResistanceThermique.Show()
    End Sub
    Private Sub BtnUPlaf_Click(sender As Object, e As EventArgs) Handles BtnUPlaf.Click
        Type_Calcul = 2
        frmResistanceThermique.Show()
    End Sub

    Private Sub BtnUSol_Click(sender As Object, e As EventArgs) Handles BtnUSol.Click
        Type_Calcul = 3
        frmResistanceThermique.Show()
    End Sub
    ''' <summary>Lecture des caractéristiques du mur</summary>
    ''' <param name="i">n° du mur et pas l'index</param>
    ''' <param name="Verif">renvoie False si pb de lecture</param>
    Private Sub LecturePv(ByVal i As Integer, ByRef Verif As Boolean)
        Dim Paroi As New ClsParoi
        If gestionderreur(TxtLatAire, EP1) = True Then Paroi.Aire = CDbl(TxtLatAire.Text) Else Verif = False
        If gestionderreur(TxtLatU, EP1) = True Then Paroi.Uth = CDbl(TxtLatU.Text) Else Verif = False
        If gestionderreur(TxtLatTe, EP1) = True Then Paroi.θext = CDbl(TxtLatTe.Text) Else Verif = False
        If Verif = False Then Exit Sub
        If i > Murs.Count Then 'i correspond à l'index et pas au n° de travée
            If Verif = True Then Murs.Add(Paroi)
        Else
            With Murs.Item(i - 1)
                .Aire = Paroi.Aire : .Uth = Paroi.Uth : .θext = Paroi.θext
            End With
        End If
    End Sub
    ''' <summary>Affichage des caractéristiques du mur</summary>
    ''' <param name="i">n° du produit et pas l'index</param>
    Private Sub AffichageMurs(ByVal i As Integer)
        With Murs.Item(i - 1)
            TxtLatAire.Text = .Aire.ToString("#0.00")
            TxtLatU.Text = .Uth.ToString("#0.000")
            TxtLatTe.Text = .θext.ToString("#0.0")
        End With
    End Sub
    Private Sub BtnPlus_Click(sender As Object, e As EventArgs) Handles BtnPlus.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbParois.Text)   ' 
        Call LecturePv(i, Verif)
        If Verif = False Then Exit Sub
        i = CInt(LblnbParois.Text) + 1
        If i > CInt(TxtTotalParois.Text) Then Exit Sub
        BtnMoins.Visible = True
        LblnbParois.Text = i.ToString
        If CInt(LblnbParois.Text) = CInt(TxtTotalParois.Text) Then BtnPlus.Visible = False 'pour ne pas afficher la flèche de travée suivante

        If Murs.Count >= i Then
            Call AffichageMurs(i)
        Else
            TxtLatAire.Text = ""
            TxtLatU.Text = ""
            TxtLatTe.Text = ""
        End If
    End Sub
    Private Sub BtnMoins_Click(sender As Object, e As EventArgs) Handles BtnMoins.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbParois.Text)   'car la collection commence à 0
        Call LecturePv(i, Verif)
        If Verif = False Then Exit Sub ' Pour continuer, il faudra soit supprimer la travée soit corriger l'erreur
        i = i - 1
        If i < 1 Then i = 1
        LblnbParois.Text = i.ToString
        Call AffichageMurs(i)
        If i = 1 Then BtnMoins.Visible = False
        If i < CInt(TxtTotalParois.Text) Then BtnPlus.Visible = True
    End Sub
    Private Sub BtnSupprimer_Click(sender As Object, e As EventArgs) Handles BtnSupprimer.Click
        Dim i As Integer
        i = CInt(LblnbParois.Text)   'car la collection commence à 0
        If Murs.Count >= i Then
            Murs.RemoveAt(i - 1)
            i = i - 1
            If i = 0 Then i = 1
            LblnbParois.Text = i.ToString
            Call AffichageMurs(i)
        End If
    End Sub

    Private Sub ChkbDallage_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbDallage.CheckedChanged
        If ChkbDallage.Checked = True Then Sol.Dallage = True Else Sol.Dallage = False
    End Sub
#End Region

#Region "Onglet Déperditions ventilateur, personnel, ..."
    Private Sub RbtnVentilateurRatio_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnVentilateurRatio.CheckedChanged
        If RbtnVentilateurRatio.Checked = True Then
            LblVentiloRatio.Visible = True : TxtVentRatio.Visible = True : lblVentiloUnite.Visible = True : BtnHlpVentiloRatio.Visible = True
            lblVentiloNb.Visible = False : TxtVentNb.Visible = False : lblVentiloPu.Visible = False : TxtVentPu.Visible = False : lblventiloPuUnite.Visible = False
        End If
    End Sub
    Private Sub RbtnVentilateurNb_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnVentilateurNb.CheckedChanged
        If RbtnVentilateurRatio.Checked = True Then
            LblVentiloRatio.Visible = True : TxtVentRatio.Visible = True : lblVentiloUnite.Visible = True : BtnHlpVentiloRatio.Visible = True
            lblVentiloNb.Visible = False : TxtVentNb.Visible = False : lblVentiloPu.Visible = False : TxtVentPu.Visible = False : lblventiloPuUnite.Visible = False
        End If
    End Sub
    Private Sub RbtnEclRatio_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnEclRatio.CheckedChanged
        If RbtnEclRatio.Checked = True Then
            LblEclRatio.Visible = True : TxtEclRatio.Visible = True : lblEclRatioUnite.Visible = True : LblEclRatioTemps.Visible = True : TxtEclRatioTemp.Visible = True : LblEclRatioTempsU.Visible = True
            lblEclNbLuminaire.Visible = False : TxtEclNb.Visible = False : lblEclPu.Visible = False : TxtEclPu.Visible = False : lblEclPuUnite.Visible = False : LblEcTemps.Visible = False : TxtEclTemp.Visible = False : LblEclTempsU.Visible = False
        End If

    End Sub
    Private Sub RbtnEclNb_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnEclNb.CheckedChanged
        If RbtnEclNb.Checked = True Then
            LblEclRatio.Visible = False : TxtEclRatio.Visible = False : lblEclRatioUnite.Visible = False : LblEclRatioTemps.Visible = False : TxtEclRatioTemp.Visible = False : LblEclRatioTempsU.Visible = False
            lblEclNbLuminaire.Visible = True : TxtEclNb.Visible = True : lblEclPu.Visible = True : TxtEclPu.Visible = True : lblEclPuUnite.Visible = True : LblEcTemps.Visible = True : TxtEclTemp.Visible = True : LblEclTempsU.Visible = True
        End If
    End Sub
#End Region

#Region "Onglet Produits stockés"
    Private Sub BtnProdPlus_Click(sender As Object, e As EventArgs) Handles BtnProdPlus.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblProdNum.Text)   'car la collection commence à 0
        Call LectureProduits(i, Verif)
        If Verif = False Then Exit Sub
        i = CInt(LblProdNum.Text) + 1
        If i > CInt(TxtProdTotal.Text) Then Exit Sub
        BtnProdMoins.Visible = True
        LblProdNum.Text = i.ToString
        If i = CInt(TxtProdTotal.Text) Then BtnProdPlus.Visible = False 'pour ne pas afficher la flèche de travée suivante

        If Matiere.Count >= i Then
            Call AffichageProduits(i)
        Else
            Call EffaceProduit()
        End If
    End Sub

    Private Sub BtnProdMoins_Click(sender As Object, e As EventArgs) Handles BtnProdMoins.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblProdNum.Text)   'car la collection commence à 0
        Call LectureProduits(i, Verif)
        If Verif = False Then Exit Sub ' Pour continuer, il faudra soit supprimer la travée soit corriger l'erreur
        i = i - 1
        If i < 1 Then i = 1
        LblProdNum.Text = i.ToString
        Call AffichageMurs(i)
        If CInt(LblProdNum.Text) = 1 Then BtnProdMoins.Visible = False
        If CInt(LblProdNum.Text) < CInt(TxtTotalParois.Text) Then BtnProdPlus.Visible = True
    End Sub
    ''' <summary>Lecture des caractéristiques des produits</summary>
    ''' <param name="i">n° du produit et pas l'index</param>
    ''' <param name="Verif">renvoie False si pb de lecture</param>
    Private Sub LectureProduits(ByVal i As Integer, ByRef Verif As Boolean)
        Dim Mat1 As New ClsProduit
        With Mat1
            .Nom = txtProdNom.Text
            If gestionderreur(TxtTempProduitEntree, EP1) = True Then .θp = CDbl(TxtTempProduitEntree.Text) Else Verif = False
            If gestionderreur(TxtCpav, EP1) = True Then .Cpav = CDbl(TxtCpav.Text) Else Verif = False
            If gestionderreur(TxtCpap, EP1) = True Then .Cpap = CDbl(TxtCpap.Text) Else Verif = False
            If gestionderreur(Txtlc, EP1) = True Then .lc = CDbl(Txtlc.Text) Else Verif = False
            If gestionderreur(TxtProdDensite, EP1) = True Then .dp = CDbl(TxtProdDensite.Text) Else Verif = False
            If gestionderreur(TxtProdTempCongel, EP1) = True Then .θpc = CDbl(TxtProdTempCongel.Text) Else Verif = False
            Select Case CbProdUnite.SelectedIndex
                Case 0 'kg
                    .ProdUnite = 0
                    If gestionderreur(Txtmprod, EP1) = True Then .mp = CDbl(Txtmprod.Text) Else Verif = False
                    If Verif = True Then .mpcal = .mp
                Case 1 'm3
                    .ProdUnite = 1
                    If gestionderreur(TxtProdDensite, EP1) = True Then .dp = CDbl(TxtProdDensite.Text) Else Verif = False
                    If gestionderreur(Txtmprod, EP1) = True Then .mp = CDbl(Txtmprod.Text) Else Verif = False
                    If Verif = True Then .mpcal = .mp * .dp
                Case 2 'Litres
                    .ProdUnite = 2
                    If gestionderreur(TxtProdDensite, EP1) = True Then .dp = CDbl(TxtProdDensite.Text) Else Verif = False
                    If gestionderreur(Txtmprod, EP1) = True Then .mp = CDbl(Txtmprod.Text) Else Verif = False
                    If Verif = True Then .mpcal = .mp * .dp
            End Select
        End With
        If Verif = False Then Exit Sub
        If i > Matiere.Count Then 'i correspond au n° du produit
            If Verif = True Then Matiere.Add(Mat1)
        Else
            With Matiere.Item(i - 1)
                .Nom = txtProdNom.Text
                .dp = 0
                If gestionderreur(TxtTempProduitEntree, EP1) = True Then .θp = CDbl(TxtTempProduitEntree.Text) Else Verif = False
                If gestionderreur(TxtCpav, EP1) = True Then .Cpav = CDbl(TxtCpav.Text) Else Verif = False
                If gestionderreur(TxtCpap, EP1) = True Then .Cpap = CDbl(TxtCpap.Text) Else Verif = False
                If gestionderreur(Txtlc, EP1) = True Then .lc = CDbl(Txtlc.Text) Else Verif = False
                If gestionderreur(TxtProdTempCongel, EP1) = True Then .θpc = CDbl(TxtProdTempCongel.Text) Else Verif = False
                Select Case CbProdUnite.SelectedIndex
                    Case 0 'kg
                        .ProdUnite = 0
                        If gestionderreur(Txtmprod, EP1) = True Then .mp = CDbl(Txtmprod.Text) Else Verif = False
                        If Verif = True Then .mpcal = .mp
                    Case 1 'm3
                        .ProdUnite = 1
                        If gestionderreur(TxtProdDensite, EP1) = True Then .dp = CDbl(TxtProdDensite.Text) Else Verif = False
                        If gestionderreur(Txtmprod, EP1) = True Then .mp = CDbl(Txtmprod.Text) Else Verif = False
                        If Verif = True Then .mpcal = .mp * .dp
                    Case 2 'Litres
                        .ProdUnite = 2
                        If gestionderreur(TxtProdDensite, EP1) = True Then .dp = CDbl(TxtProdDensite.Text) Else Verif = False
                        If gestionderreur(Txtmprod, EP1) = True Then .mp = CDbl(Txtmprod.Text) Else Verif = False
                        If Verif = True Then .mpcal = .mp * .dp
                End Select

            End With
        End If
    End Sub
    ''' <summary>Affichage des caractéristiques des produits</summary>
    ''' <param name="i">n° du produit et pas l'index</param>
    Private Sub AffichageProduits(ByVal i As Integer)
        With Matiere.Item(i - 1)
            txtProdNom.Text = .Nom
            TxtTempProduitEntree.Text = .θp.ToString("#0.0")
            TxtCpav.Text = .Cpav.ToString("#0.000")
            TxtCpap.Text = .Cpap.ToString("#0.000")
            Txtlc.Text = .lc.ToString("#0.000")
            TxtProdTempCongel.Text = .θpc.ToString("#0.0")
            Select Case .ProdUnite
                Case 0 'kg.ProdUnite = 0
                    Txtmprod.Text = .mp.ToString("#0.0")
                    CbProdUnite.Text = CbProdUnite.Items(0).ToString
                    lblProdDensite.Visible = False : TxtProdDensite.Visible = False : LblDensite.Visible = False
                Case 1 'm3.ProdUnite = 1
                    Txtmprod.Text = .mp.ToString("#0.000")
                    CbProdUnite.Text = CbProdUnite.Items(1).ToString
                    lblProdDensite.Visible = True : TxtProdDensite.Visible = True : LblDensite.Visible = True : LblDensite.Text = "(Kg/m3)"
                    TxtProdDensite.Text = .dp.ToString("#0.0")
                Case 2 'Litres .ProdUnite = 2
                    Txtmprod.Text = .mp.ToString("#0.0")
                    CbProdUnite.Text = CbProdUnite.Items(2).ToString
                    lblProdDensite.Visible = True : TxtProdDensite.Visible = True : LblDensite.Visible = True : LblDensite.Text = "(Kg/m3)"
                    TxtProdDensite.Text = .dp.ToString("#0.0")
            End Select
        End With
    End Sub
    Private Sub EffaceProduit()
        txtProdNom.Text = ""
        TxtTempProduitEntree.Text = ""
        TxtCpav.Text = ""
        TxtCpap.Text = ""
        Txtlc.Text = ""
        TxtProdDensite.Text = ""
        TxtProdTempCongel.Text = ""
        Txtmprod.Text = ""
    End Sub
    Private Sub BtnProdSuppression_Click(sender As Object, e As EventArgs) Handles BtnProdSuppression.Click
        Dim i As Integer
        i = CInt(LblProdNum.Text) 'car la collection commence à 0
        If Matiere.Count >= i Then
            Matiere.RemoveAt(i - 1)
            i = i - 1
            If i = 0 Then i = 1
            LblProdNum.Text = i.ToString
            Call AffichageProduits(i)
        End If
    End Sub
    Private Sub CbProdUnite_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbProdUnite.SelectedIndexChanged
        Select Case CbProdUnite.SelectedIndex
            Case 0 'kg
                lblProdDensite.Visible = False : TxtProdDensite.Visible = False : LblDensite.Visible = False
            Case 1 'm3
                lblProdDensite.Visible = True : TxtProdDensite.Visible = True : LblDensite.Visible = True : LblDensite.Text = "(Kg/m3)"
            Case 2 'Litres
                lblProdDensite.Visible = True : TxtProdDensite.Visible = True : LblDensite.Visible = True : LblDensite.Text = "(Kg/L)"
        End Select
    End Sub
    Private Sub LBoxProduit_SelectedIndexChanged(sender As Object, e As EventArgs) Handles LBoxProduit.SelectedIndexChanged
        Dim i As Integer
        i = LBoxProduit.SelectedIndex
        With Matieres_Prestockees.Item(i)
            txtProdNom.Text = .Nom : TxtTempProduitEntree.Text = "0" : TxtCpav.Text = .Cpav.ToString("#0.000") : TxtCpap.Text = .Cpap.ToString("#0.000") : Txtlc.Text = .lc.ToString("#0.000") : TxtProdDensite.Text = .dp.ToString("#0.0")
            TxtProdTempCongel.Text = .θpc.ToString("#0.0") : Txtmprod.Text = .mp.ToString("#0.0")
        End With

    End Sub
#End Region

    Private Sub frmChFroide_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim filename As String = String.Empty
        Dim Verif As Boolean = True
        Try
            '--> création des répertoires data et note de calcul si n'existe pas
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Data") = False Then
                My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Data")
            End If
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Resultat") = False Then
                My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Resultat")
            End If
            '--> création des répertoires Aide si n'existe pas
            'ce qui est le cas lors de l'installation du logiciel
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Aide") = False Then
                Try
                    '  Dim startPath As String = Directory.GetCurrentDirectory.ToString() ' & ".\start"
                    Dim zipPath As String = Directory.GetCurrentDirectory.ToString() & "\Aide.zip"
                    My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Aide")
                    Dim extractPath As String = Directory.GetCurrentDirectory.ToString() & "\Aide"
                    '   System.IO.Compression.ZipFile.CreateFromDirectory(startPath, zipPath)
                    System.IO.Compression.ZipFile.ExtractToDirectory(zipPath, extractPath)

                Catch ex As Exception
                    MessageBox.Show("Problème de décompression du fichier Aide.zip" & Environment.NewLine & "Exception: " + ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            End If

            '--> création du fichier ini si n'existe pas
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_CalculFrigo.ini"
            If File.Exists(filename) = False Then
                Call Variables_generales() 'appel au modules contenant les variables par defaut
                Call frmConfig.Ecriture_fichier_Cfg_ini(filename) 'creation du fichier lors de l'installation du logiciel
            Else

                'Affichage des valeurs en cours
                Try
                    Call Variables_generales() 'lecture variables par defaut
                    Call Lecture_Fichier_Cfg_ini(filename, Verif) 'Initialisation du logiciel avec les préférences de l'utilisateur
                    If Verif = False Then
                        Call Variables_generales() 'appel aux variables générales inscrites en dur dans le logiciel
                        MessageBox.Show("Appel à la configuration par défaut", "Module démarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    End If
                Catch exc As Exception
                    MessageBox.Show("Erreur lors du chargement du logiciel:" + Environment.NewLine + "Exception: " + exc.Message, "Module général", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Call Variables_generales() 'appel aux variables générales inscrites en dur dans le logiciel
                    MessageBox.Show("Appel à la configuration par défaut", "Module démarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End Try
            End If
        Catch ex As Exception
            Exit Sub
        End Try


        Call Initialisation()

    End Sub
    Private Sub Initialisation()
        'onglet Caractéristique générale
        RbtnChPositive.Checked = True
        RbtnApportThermique_Calcul.Checked = True
        LbService.Visible = False : BtnHlpService.Visible = False
        ' Onglet Parois
        BtnMoins.Visible = False
        'Onglet Apport
        RbtnVentilateurRatio.Checked = True
        RbtnEclRatio.Checked = True
        'onglet Produits stockés
        BtnProdMoins.Visible = False
        CbProdUnite.Text = CbProdUnite.Items(0).ToString ' kg
        LBoxProduit.Items.Clear()
        For i = 0 To Matieres_Prestockees.Count - 1
            LBoxProduit.Items.Add(Matieres_Prestockees.Item(i).Nom)
        Next
    End Sub

    Private Sub BtnConfig_Click(sender As Object, e As EventArgs) Handles BtnConfig.Click
        Dim frm1 As New frmConfig
        frm1.Show()
        frm1 = Nothing 'pour libérer la mémoire
    End Sub
    Private Sub BtnEdit_Click(sender As Object, e As EventArgs) Handles BtnEdit.Click
        Try
            With Aff
                Select Case .Editeur
                    Case 1 'Editeur Interne
                        Dim frm1 As New Editeur.frmEdit
                        frm1.Affichage_frmEdit(.FileNoteCalcul)
                    Case 2 'éditeur Word
                        Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                        Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                        startInfo.WindowStyle = ProcessWindowStyle.Normal
                        startInfo.Arguments = .FileNoteCalcul
                        Process.Start(startInfo.Arguments)
                End Select
            End With
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub

    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim Verif As Boolean = True
        'remise à zero générale
        Call Variables_generales()
        'Appel au nouveau fichier
        Try
            With OpenFileDialog1

                If Aff.msgData <> String.Empty Then
                    .InitialDirectory = Aff.msgData 'pour démarrer toujours sur le bon répertoire
                Else
                    .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
                End If
                .FileName = "" 'pour éviter tout affichage initial dans la boite de dialogue
                .CheckFileExists = True ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .DefaultExt = "txt" ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                .ShowHelp = True ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ? Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Aff.FileName = OpenFileDialog1.FileName
                        Dim toto As String = Aff.FileName
                        Dim Racine As String = String.Empty
                        Call Lecture_chaine(toto, Racine)
                        Call DeSerializeData(Racine, Verif)
                        If Verif = True Then
                            'la deserialization est OK
                            Call Affichage_Onglets()
                            TC1.SelectTab(0)
                        End If
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
        End Try

    End Sub
    Private Sub Lecture_chaine(ByRef toto As String, ByRef Racine As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        Try
            Dim i, i1, position As Integer
            Dim tutu As String = String.Empty
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            i1 = i
            position = InStrRev(toto, "\")
            i = i - position
            tutu = toto
            i1 = i1 - i
            toto = Microsoft.VisualBasic.Right(toto, i)
            Racine = Microsoft.VisualBasic.Left(tutu, i1)
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du la chaine " & toto.ToString & Environment.NewLine + ex.Message & ex.StackTrace, "Module Lecture_Chaine", MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
        End Try

    End Sub
    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click
        Dim Verif As Boolean = True

        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Call Lecture_Onglets(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans les onglets", "frmChFroide Sub Lecture_Onglets", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        'écriture des données dans les fichiers de sauvegarde
                        Aff.FileName = .FileName
                        Call SerializeData() '
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la sauvegarde: " + Environment.NewLine + ex.Message & ex.StackTrace, "frmChFroide Sub BtnSauvegarde_Click", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub BtnAide_Click(sender As Object, e As EventArgs) Handles BtnAide.Click
        'PDFExe = CType(Microsoft.Win32.Registry.GetValue("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.pdf\OpenWithList", "C", ""), String)   'récupère le reader par défaut
        Try
            Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("acroPDF.PDF")
            If KEY Is Nothing Then
                MessageBox.Show("Impossible d'accèder à Acrobat Reader!" & Environment.NewLine & "Lecture manuel d'utilisation abandonné.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
            Dim startInfo As New ProcessStartInfo("AcroRd32.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = SousDossier1 & "\CalculFrigo_Notice.pdf"
            Process.Start(startInfo.Arguments)

        Catch ex As Exception
            Dim msg As String = String.Empty
            msg = "Impossible d'afficher le manuel d'utilisation" & Environment.NewLine & "Exception: " + ex.Message
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub BtnApropos_Click(sender As Object, e As EventArgs) Handles BtnApropos.Click
        Try
            My.Forms.frmSplash.Close()
            'Dim ADUpdateAsync As Deployment.Application.ApplicationDeployment
            'ADUpdateAsync = Deployment.Application.ApplicationDeployment.CurrentDeployment
            'Dim version As String = ADUpdateAsync.CurrentVersion.ToString()
            My.Forms.frmSplash.Width = 500 : My.Forms.frmSplash.Height = 450
            My.Forms.frmSplash.StartPosition = FormStartPosition.CenterScreen
            'My.Forms.frmSplash.LblVersion.Text = "Version " & Version
            My.Forms.frmSplash.Show()
        Catch ex As Exception
            MessageBox.Show("Affichage Version logicielle impossible!" & Environment.NewLine & "Erreur:" & Environment.NewLine & ex.ToString, "Affichage version logicielle", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            My.Forms.frmSplash.Width = 453 : My.Forms.frmSplash.Height = 450
            My.Forms.frmSplash.StartPosition = FormStartPosition.CenterScreen
            My.Forms.frmSplash.LblVersion.Text = "Version non identifiable"
            My.Forms.frmSplash.Show()
        End Try
    End Sub

#Region "Bouton d'aide par onglet"
    Private Sub BtnHlpnbHeuresGC_Click(sender As Object, e As EventArgs) Handles BtnHlpnbHeuresGC.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 1
        frm1.Show()
    End Sub

    Private Sub BtnHlpService_Click(sender As Object, e As EventArgs) Handles BtnHlpService.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 2
        frm1.Show()
    End Sub

    Private Sub BtnHlpTempIntChFroide_Click(sender As Object, e As EventArgs) Handles BtnHlpTempIntChFroide.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 3
        frm1.Show()
    End Sub

    Private Sub BtnHlpHumidite_Click(sender As Object, e As EventArgs) Handles BtnHlpHumidite.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 4
        frm1.Show()
    End Sub
    Private Sub BtnHlpParois_Click(sender As Object, e As EventArgs) Handles BtnHlpParois.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 6
        frm1.Show()
    End Sub

    Private Sub BtnHlpSol_Click(sender As Object, e As EventArgs) Handles BtnHlpSol.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 7
        frm1.Show()
    End Sub

    Private Sub BtnHlpProduitsstockes_Click(sender As Object, e As EventArgs) Handles BtnHlpProduitsstockes.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 8
        frm1.Show()
    End Sub
#Region "Onglet Apport toute chambre"
    Private Sub BtnHlpVentiloRatio_Click(sender As Object, e As EventArgs) Handles BtnHlpVentiloRatio.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 9
        frm1.Show()
    End Sub

    Private Sub BtnHlpPersonnel_Click(sender As Object, e As EventArgs) Handles BtnHlpPersonnel.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 10
        frm1.Show()
    End Sub

    Private Sub BtnHlpEclairage_Click(sender As Object, e As EventArgs) Handles BtnHlpEclairage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 11
        frm1.Show()
    End Sub

    Private Sub BtnHlpMachine_Click(sender As Object, e As EventArgs) Handles BtnHlpMachine.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 12
        frm1.Show()
    End Sub

    Private Sub BtnHlpOuverturePorte_Click(sender As Object, e As EventArgs) Handles BtnHlpOuverturePorte.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 13
        frm1.Show()
    End Sub

#End Region
#Region "Onglet Apport chambre négative"
    Private Sub BtnHlpResistDegivrage_Click(sender As Object, e As EventArgs) Handles BtnHlpResistDegivrage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 14
        frm1.Show()
    End Sub

    Private Sub BtnHlpCordonPorte_Click(sender As Object, e As EventArgs) Handles BtnHlpCordonPorte.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 15
        frm1.Show()
    End Sub

    Private Sub BtnHlpRubanClapet_Click(sender As Object, e As EventArgs) Handles BtnHlpRubanClapet.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 16
        frm1.Show()
    End Sub

    Private Sub BtnHlpCordonTuyauterie_Click(sender As Object, e As EventArgs) Handles BtnHlpCordonTuyauterie.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 17
        frm1.Show()
    End Sub
#End Region
#End Region


#Region "Gestion des textbox"
#Region "Onglet caractéristiques générales"
    Private Sub TxtTemperature_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTemperature.KeyPress
        Call Gestion_Keypress(e, TxtTemperature, True, False)
    End Sub
    Private Sub TxtHrHaut_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtHrHaut.KeyPress
        Call Gestion_Keypress(e, TxtHrHaut, True, False)
    End Sub

    Private Sub TxtHrBas_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtHrBas.KeyPress
        Call Gestion_Keypress(e, TxtHrBas, True, False)
    End Sub
    Private Sub TxtGroupCondensationNbHeure_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtGroupCondensationNbHeure.KeyPress
        Call Gestion_Keypress(e, TxtGroupCondensationNbHeure, True, False)
    End Sub
#End Region

#Region "Onglet Parois"
    Private Sub TxtTotalParois_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTotalParois.KeyPress
        Call Gestion_Keypress(e, TxtTotalParois, True, True)
    End Sub
    Private Sub TxtLatTe_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLatTe.KeyPress
        Call Gestion_Keypress(e, TxtLatTe, True, False)
    End Sub

    Private Sub TxtLatU_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLatU.KeyPress
        Call Gestion_Keypress(e, TxtLatU, True, False)
    End Sub

    Private Sub TxtLatAire_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLatAire.KeyPress
        Call Gestion_Keypress(e, TxtLatAire, True, False)
    End Sub

    Private Sub TxtPlafAire_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPlafAire.KeyPress
        Call Gestion_Keypress(e, TxtPlafAire, True, False)
    End Sub

    Private Sub TxtPlafTe_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPlafTe.KeyPress
        Call Gestion_Keypress(e, TxtPlafTe, True, False)
    End Sub

    Private Sub TxtPlafU_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPlafU.KeyPress
        Call Gestion_Keypress(e, TxtPlafU, True, False)
    End Sub

    Private Sub TxtSolAire_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtSolAire.KeyPress
        Call Gestion_Keypress(e, TxtSolAire, True, False)
    End Sub

    Private Sub TxtSolTe_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtSolTe.KeyPress
        Call Gestion_Keypress(e, TxtSolTe, True, False)
    End Sub

    Private Sub TxtSolU_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtSolU.KeyPress
        Call Gestion_Keypress(e, TxtSolU, True, False)
    End Sub
#End Region

#Region "Onglet Apports thermiques"
    Private Sub TxtVentRatio_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtVentRatio.KeyPress
        Call Gestion_Keypress(e, TxtVentRatio, True, False)
    End Sub

    Private Sub TxtVentNb_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtVentNb.KeyPress
        Call Gestion_Keypress(e, TxtVentNb, True, True)
    End Sub

    Private Sub TxtVentPu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtVentPu.KeyPress
        Call Gestion_Keypress(e, TxtVentPu, True, False)
    End Sub
    Private Sub TxtPersoNb_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPersoNb.KeyPress
        Call Gestion_Keypress(e, TxtPersoNb, True, True)
    End Sub

    Private Sub TxtPersoPu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPersoPu.KeyPress
        Call Gestion_Keypress(e, TxtPersoPu, True, False)
    End Sub

    Private Sub TxtPersoTemps_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPersoTemps.KeyPress
        Call Gestion_Keypress(e, TxtPersoTemps, True, False)
    End Sub
    Private Sub TxtEclRatio_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEclRatio.KeyPress
        Call Gestion_Keypress(e, TxtEclRatio, True, False)
    End Sub

    Private Sub TxtEclNb_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEclNb.KeyPress
        Call Gestion_Keypress(e, TxtEclNb, True, True)
    End Sub

    Private Sub TxtEclPu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEclPu.KeyPress
        Call Gestion_Keypress(e, TxtEclPu, True, False)
    End Sub
    Private Sub TxtEclRatioTemp_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEclRatioTemp.KeyPress
        Call Gestion_Keypress(e, TxtEclRatioTemp, True, False)
    End Sub
    Private Sub TxtEclTemp_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEclTemp.KeyPress
        Call Gestion_Keypress(e, TxtEclTemp, True, False)
    End Sub
    Private Sub TxtMachinePt_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtMachinePt.KeyPress
        Call Gestion_Keypress(e, TxtMachinePt, True, False)
    End Sub

    Private Sub TxtMachineTemps_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtMachineTemps.KeyPress
        Call Gestion_Keypress(e, TxtMachineTemps, True, False)
    End Sub
#End Region

#Region "Onglet Apports thermiques chambre froide négative"
    Private Sub TxtDegivragePu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtDegivragePu.KeyPress
        Call Gestion_Keypress(e, TxtDegivragePu, True, False)
    End Sub

    Private Sub TxtDegivrageH_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtDegivrageH.KeyPress
        Call Gestion_Keypress(e, TxtDegivrageH, True, False)
    End Sub

    Private Sub TxtCordonPortePu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCordonPortePu.KeyPress
        Call Gestion_Keypress(e, TxtCordonPortePu, True, False)
    End Sub

    Private Sub TxtCordonPorteH_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCordonPorteH.KeyPress
        Call Gestion_Keypress(e, TxtCordonPorteH, True, False)
    End Sub

    Private Sub TxtRubanClapetPu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtRubanClapetPu.KeyPress
        Call Gestion_Keypress(e, TxtRubanClapetPu, True, False)
    End Sub

    Private Sub TxtRubanClapetH_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtRubanClapetH.KeyPress
        Call Gestion_Keypress(e, TxtRubanClapetH, True, False)
    End Sub
    Private Sub TxtCordonTuyauteriePu_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCordonTuyauteriePu.KeyPress
        Call Gestion_Keypress(e, TxtCordonTuyauteriePu, True, False)
    End Sub

    Private Sub TxtCordonTuyauterieH_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCordonTuyauterieH.KeyPress
        Call Gestion_Keypress(e, TxtCordonTuyauterieH, True, False)
    End Sub


#End Region

#Region "Produits stockés"
    Private Sub TxtTempProduitEntree_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTempProduitEntree.KeyPress
        Call Gestion_Keypress(e, TxtTempProduitEntree, False, False)
    End Sub

    Private Sub TxtProdDensite_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtProdDensite.KeyPress
        Call Gestion_Keypress(e, TxtProdDensite, True, False)
    End Sub

    Private Sub TxtProdTempCongel_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtProdTempCongel.KeyPress
        Call Gestion_Keypress(e, TxtProdTempCongel, False, False)
    End Sub

    Private Sub TxtCpap_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCpap.KeyPress
        Call Gestion_Keypress(e, TxtCpap, True, False)
    End Sub

    Private Sub TxtCpav_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCpav.KeyPress
        Call Gestion_Keypress(e, TxtCpav, True, False)
    End Sub

    Private Sub Txtlc_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txtlc.KeyPress
        Call Gestion_Keypress(e, Txtlc, True, False)
    End Sub

    Private Sub Txtmprod_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txtmprod.KeyPress
        Call Gestion_Keypress(e, Txtmprod, True, False)
    End Sub

    Private Sub TxtProdTotal_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtProdTotal.KeyPress
        Call Gestion_Keypress(e, TxtProdTotal, True, True)
    End Sub

#End Region
#End Region

End Class
