﻿Public Class frmResistanceThermique
    Private nbCouche As Integer = 1
    Private ep(), λ() As Double
    Private Sub frmResistanceThermique_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Call initialisation()
    End Sub
    Private Sub initialisation()
        BtnMoins.Visible = False
        LblU1.Visible = False : LblU2.Visible = False : lblUventil.Visible = False : lblUventilNon.Visible = False : Lblunite1.Visible = False : Lblunite2.Visible = False
        lblParoi.Visible = False : lblVentile.Visible = False : lblNonVentile.Visible = False
    End Sub

    Private Sub BtnUlat_Click(sender As Object, e As EventArgs) Handles BtnUlat.Click
        Dim Verif As Boolean = True
        Dim Uv, Unonv As Double
        Dim i As Integer
        i = CInt(LblnbCouche.Text)
        Call Lecture(i, Verif)
        If Verif = False Then Exit Sub
        Call Coef_U(frmChFroide.Type_Calcul, nbCouche, ep, λ, Uv, Unonv, Verif)
        If Verif = False Then Exit Sub
        Call Affichage_resultat(Uv, Unonv)
    End Sub
    Private Sub Affichage_resultat(ByVal Uv As Double, ByVal Unonv As Double)
        lblParoi.Visible = True : lblVentile.Visible = True : lblNonVentile.Visible = True
        LblU1.Visible = True : LblU2.Visible = True : Lblunite1.Visible = True : Lblunite2.Visible = True
        lblUventil.Visible = True : lblUventilNon.Visible = True
        lblUventil.Text = Uv.ToString("#0.000")
        lblUventilNon.Text = Unonv.ToString("#0.000")
        Select Case frmChFroide.Type_Calcul
            Case 1 'paroi latérale
                lblParoi.Text = "Paroi verticale - Flux horizontal"
                lblVentile.Text = "Face externe ventilée type passage ouvert/ local ouvert"
                lblNonVentile.Text = "Face externe non ventilée type local fermé"
            Case 2 'plafond
                lblParoi.Text = "Plafond - Flux vers le bas"
                lblVentile.Text = "Face externe ventilée type passage ouvert/ local ouvert/ comble ventilé"
                lblNonVentile.Text = "Face externe non ventilée type comble non ou peu ventilé/ local fermé"
            Case 3 'sol
                lblParoi.Text = "Sol - Flux vers le haut"
                Select Case Sol.Dallage
                    Case True 'If ChkbDallage.Checked = True Then Sol.Dallage = True Else Sol.Dallage = False
                        LblU1.Visible = False : lblUventil.Visible = False : Lblunite1.Visible = False : lblVentile.Visible = False
                    Case False
                        LblU1.Visible = True : lblUventil.Visible = True : Lblunite1.Visible = True : lblVentile.Visible = True
                End Select
                lblVentile.Text = "Face externe ventilée type passage ouvert/ local ouvert"
                lblNonVentile.Text = "Face externe non ventilée type vide sanitaire non ou peu ventilé/ dallage"
        End Select

    End Sub
    ''' <summary>Lecture des caractéristiques de la paroi</summary>
    ''' <param name="i">n° du mur et pas l'index</param>
    ''' <param name="Verif">renvoie False si pb de lecture</param>
    Private Sub Lecture(ByRef i As Integer, ByRef Verif As Boolean)
        ReDim Preserve ep(nbCouche), λ(nbCouche)
        If gestionderreur(Txtep, EP1) = True Then ep(i) = (CDbl(Txtep.Text)) / 1000 Else Verif = False
        If gestionderreur(TxtLambda, EP1) = True Then λ(i) = CDbl(TxtLambda.Text) Else Verif = False
    End Sub
    ''' <summary>Affichage des caractéristiques de la paroi</summary>
    ''' <param name="i">n° de la paroi et pas l'index</param>
    Private Sub Affichage_donnees(ByVal i As Integer)
        Txtep.Text = (ep(i) * 1000).ToString("#0") 'en mm
        TxtLambda.Text = λ(i).ToString("#0.000")
    End Sub
    Private Sub BtnPlus_Click(sender As Object, e As EventArgs) Handles BtnPlus.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbCouche.Text)
        Call Lecture(i, Verif)
        If Verif = False Then Exit Sub
        i = CInt(LblnbCouche.Text) + 1
        nbCouche = CInt(txtTotal.Text)
        If i > nbCouche Then BtnPlus.Visible = False : Exit Sub
        BtnMoins.Visible = True
        LblnbCouche.Text = i.ToString
        If CInt(LblnbCouche.Text) = nbCouche Then BtnPlus.Visible = False 'pour ne pas afficher la flèche de travée suivante

        If ep.Length > i AndAlso λ.Length > i Then
            Call Affichage_donnees(i)
        Else
            Txtep.Text = "" : TxtLambda.Text = ""
        End If
    End Sub

    Private Sub BtnMoins_Click(sender As Object, e As EventArgs) Handles BtnMoins.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbCouche.Text)
        Call Lecture(i, Verif)
        If Verif = False Then Exit Sub ' Pour continuer, il faudra soit supprimer la travée soit corriger l'erreur
        LblnbCouche.Text = i.ToString
        i = i - 1
        If i < 0 Then i = 1
        LblnbCouche.Text = i.ToString
        Call Affichage_donnees(i)
        If i = 1 Then BtnMoins.Visible = False
        If i < nbCouche Then BtnPlus.Visible = True
    End Sub

#Region "Gestion des textbox"
    Private Sub txtTotal_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtTotal.KeyPress
        Call Gestion_Keypress(e, txtTotal, True, True)
    End Sub

    Private Sub Txtep_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txtep.KeyPress
        Call Gestion_Keypress(e, Txtep, True, True)
    End Sub
    Private Sub TxtLambda_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLambda.KeyPress
        Call Gestion_Keypress(e, TxtLambda, True, False)
    End Sub


#End Region

    Private Sub BtnHlpLambda_Click(sender As Object, e As EventArgs) Handles BtnHlpLambda.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 5
        frm1.Show()
    End Sub
End Class